﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;
using CG2.Lighting;
//using CG2.Texturing;

namespace CG2.Shading
{
	public class Phong : Shader
	{
		#region Properties

        //public Sampler DiffuseSampler = new ColorSampler(new Vector4(1.0, 1.0, 1.0));
        //public Sampler SpecularSampler = new ColorSampler(new Vector4(0.6, 0.6, 0.6));
        //public Sampler AmbientSampler = new ColorSampler(new Vector4(0.1, 0.1, 0.1));
        public Vector4 DiffuseColor = new Vector4(1, 1, 1);
        public Vector4 SpecularColor = new Vector4(0.6, 0.6, 0.6);
        public Vector4 AmbientColor = new Vector4(0, 0, 0);
        //public Sampler NormalSampler = null;
		public Double Shininess = 10;

		#endregion


		#region Init

		public Phong()
		{
		}

		public Phong(Vector4 diffuseColor)
		{
            //DiffuseSampler = new ColorSampler(diffuseColor);
            DiffuseColor = diffuseColor;
		}

		public Phong(Vector4 diffuseColor, Vector4 specularColor)
		{
            //DiffuseSampler = new ColorSampler(diffuseColor);
            //SpecularSampler = new ColorSampler(specularColor);
            DiffuseColor = diffuseColor;
            SpecularColor = specularColor;
		}

        public Phong(Vector4 diffuseColor, Vector4 specularColor, Vector4 ambientColor)
		{
            //DiffuseSampler = new ColorSampler(diffuseColor);
            //SpecularSampler = new ColorSampler(specularColor);
            //AmbientSampler = new ColorSampler(ambientColor);
            DiffuseColor = diffuseColor;
            SpecularColor = specularColor;
            AmbientColor = ambientColor;
		}

		#endregion


		#region Shading

        public override Vector4 GetNormal(Vector4 point, Vector4 normal)
        {
            //if (NormalSampler == null) return normal;

            //Else return deformed normal by Normal Sampler
            return Vector4.Zero;
        }

        public override Vector4 GetColor(Vector4 point, Vector4 normal, Vector4 eyeDir, Vector4 lightDir, Double lightIntensity, Light light)
        {
            Double diffuseFactor = lightIntensity * (normal * lightDir);
            if (diffuseFactor < 0) diffuseFactor = 0;

            Vector4 half = (lightDir + eyeDir).Normalized;
            Double specularFactor = lightIntensity * Math.Pow(normal * half, Shininess);

            // Get sample of DiffuseSampler at texture coordinates calculated with DiffuseMapping at given point
            // Get sample of SpecularSampler at texture coordinates calculated with SpecularMapping at given point
            // Get sample of AmbientSampler at texture coordinates calculated with AmbientMapping at given point
            
            
            //Calculate phong but include also an alpha chanel of the texture - see Homer texture and Scene2- plane mapping
            Vector4 color = new Vector4();
            return color;
		}

		#endregion
	}
}
