﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;

namespace CG2.Texturing
{
	public class PlaneMapping : TextureMapping
	{
		#region Properties

        // Declare Origin of mapping plane
		public Vector4 Origin;

        // Declare U and V direction vectors of plane mapping
		public Vector4 U;
		public Vector4 V;

        protected Vector4 unitU, unitV, n;

		#endregion


		#region Init

		public PlaneMapping(Vector4 origin, Vector4 u, Vector4 v)
		{
            // Init given parameters
			Origin = origin;
			U = u;
			V = v;

            // ToDo: Precompute uu, vv, uv, k, n (see mesh ray intersection)
            unitU = U.Normalized;
            unitV = V.Normalized;
		}

		#endregion


		#region Mapping

        public override void GetTangetSpace(Vector4 point, out Vector4 u, out Vector4 v, out Vector4 w)
        {
            // set u,v,w being base vectors for the tangent space
            // What is tangent space?
            // Used in normal mapping
            u = unitU;
            v = unitV;
            w = n;
        }

		public override Vector4 GetCoords(Vector4 point)
		{
            // ToDo: Calculate sampling coordinates for given point based on the planar mapping
            // Hint: What is texture's point of origin and how this point looks like in 3D space? What is plane's point of origin and how would it look like in 2D space?
            // You can represent any kind of point P in 3D space as P = O + offset vector;

            return Vector4.Zero;
        }

		#endregion
	}
}
